#!/usr/bin/env python
#
# xkmap_ui.py   --  Simple GUI for xorg keymap configuring and setting

# (c) Copyright 2009-2010 Michael Towers (larch42 at googlemail dot com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------
# 2010.08.14

from xkmap_base import Xkmap
from xkmap_ui import XkmapGui

def backend(func, *args):
    """Interface between GUI and file-system accessing functions (normally
    the main, functional part of the application). The first argument is the
    function name. There may be any number of arguments, including none.
    The simplest functions, those completing quickly and without interaction,
    return a (<bool> ok, result) pair - the type of the result is open.
    Longer running functions, or those that require some interaction return
    <None>, and then communicate subsequently using 'signals'.
    """
    return getattr(app, 'fss_' + func)(*args)

if __name__ == "__main__":
    # Initialize the backend
    app = Xkmap()
    # Initialize the GUI
    xkmgui = XkmapGui(backend)
    # Tell the backend how to send signals to the GUI
    app.setuisig(xkmgui.sigin)
    # Start the application, enter the main event loop
    xkmgui.start()
